# Rotex.py	versione: 2011_10_14 Modificato By:Gasala50
# Collezione di Python class per semplificare l'uso di una scheda FOXG20

import serial
import thread
import threading
import time
import fox
from pysqlite2 import dbapi2 as sqlite

# Temperature sensor ID available on /sys/bus/w1/devices  
asensor = fox.DS18S20("000801ea499c")
bsensor = fox.DS18S20("000801d598d0")
csensor = fox.DS18S20("000801d5a5e0")
#	dsensor = fox.DS18S20("000801537dd0")
# definizione I/O
ledverde = fox.Pin('J7.3','low')
ledgiallo = fox.Pin('J7.4','low')
ledrosso = fox.Pin('J7.6','low')

Go=1

class ricevi(threading.Thread):
	def __init__ (self, ser):
		threading.Thread.__init__(self)
		self.ser=ser
	def run(self):
		T = 0
		E = 0
		TEg = 0	# Val. base per sommatore Energia Prodotta in un giorno
		TEt = 14636.6	# Val. base per totalizzatore Energia Prodotta
		DTon = 5	# Differenziale di accensione pompa riciclo
		DToff = 2	# Differenziale di spegnimento pompa riciclo
		Pt1 = 0	# Valore x Pompa di Trasferimento 1 Ferma
		Pt2 = 0	# Valore x Pompa di Trasferimento 2 Ferma

		while Go:
			s=self.ser.read(50)
			if s:
				s=str.split(s,';',8)	# lettura dati proveniente da Rotex RPS/3 
				HA=int(s[0])
				BK=int(s[1])
				P1=int(s[2])
				P2=int(s[3])
				TK=int(s[4])
				TR=int(s[5])
				TS=int(s[6])
				TV=int(s[7])
				QT=s[8]
				P=float(QT.replace(',', '.'))
# Applicazione polinomiale lineare di correzione temperatura (solo su TR)
				TRc=int(round((TR-0.5)*0.938+1.448,0))
# Calcolo Potenza istantanea ogni 5 secondi
				if P > 0:
					W=(TV-TRc)*P*0.0697
				else:
					W = 0
# Calcolo Energia
				E5 = W*0.00139	#Ciclo di 5 secondi / 3600 secondi in un'ora
				E = E + E5		#Sommatoria Energia al minuto (5 sec x 12 cicli)

# Controllo del segnale di blocco integrazione con energia elettrica (rps/3)
				if BK == 1:
					ledverde.on()
				else:
					ledverde.off()

# Controllo tempo di ciclo ogni 5 secondi
#    ledgiallo.on()
#    time.sleep(0.5)
#    ledgiallo.off()
				T = T + 1

				print HA ,BK ,P1 ,P2 ,TK ,TR ,TS ,TV ,'%.1f' %P ,'%.2f' %W ,'%.3f' %E
 
# Lettura valori di temperatura delle sonde 1-wire DS18S20 Tsa, Ts1, Ts2
				if T == 2:
					Tsa = asensor.getTemp()
					Ts1 = bsensor.getTemp()
				if T == 5:
					Tsa = asensor.getTemp()
					Ts2 = csensor.getTemp()
				if T == 8:
					Ts1 = bsensor.getTemp()
					Ts2 = csensor.getTemp()
#				if T == 10:
#					Tes = dsensor.getTemp()
				if T == 12:
					TEg = TEg + E	# Sommatoria Energia Giornaliera
					TEt = TEt + E # Contatore Energia Impianto 
# Controllo tempo ogni 60 secondi
#					ledrosso.on()
#					time.sleep(1)
#					ledrosso.off()
# Controllo temperature per attivazione Pompa di riciclo sanicube n.1
					T1 = Tsa - Ts1
					if T1 >= DTon:
						ledgiallo.on()
						time.sleep(0.4)
						Pt1 = 1
					if T1 <= DToff:
						ledgiallo.off()
						Pt1 = 0
# Controllo temperature per attivazione Pompa di riciclo sanicube n.2
					T2 = Tsa - Ts2
					if T2 >= DTon:
						ledrosso.on()
						time.sleep(0.4)
						Pt2 = 1
					if T2 <= DToff:
						ledrosso.off()
						Pt2 = 0

					print time.strftime("%Y/%m/%d", time.localtime(time.time())),\
'Ora:',time.strftime("%H:%M:%S", time.localtime(time.time())),\
'Tot.Day',"%.3f" %TEg,'Cont.',"%.3f" %TEt,'Temp.C',"%.1f" %Tsa,"%.1f" %Ts1,"%.1f" %Ts2 		#,"%.1f" %Tes

# Insert a new record on tables 'tabrps_acs' on the SQLite database "rotex"

					connection = sqlite.connect('/var/www/rotex.sqlite')
					cursor = connection.cursor()

					cursor.execute('CREATE TABLE IF NOT EXISTS tabrps_acs \
(id INTEGER PRIMARY KEY AUTOINCREMENT, date TEXT, time TEXT, BK TEXT, P1 INTEGER, P2 INTEGER,\
 TK INTEGER, TR INTEGER, TS INTEGER, TV INTEGER, Tsa FLOAT , Ts1 FLOAT, Ts2 FLOAT, P FLOAT ,\
 W FLOAT, E FLOAT, TEg FLOAT, TEt FLOAT, Pt1 INTEGER, Pt2 INTEGER)')

					cursor.execute('INSERT INTO tabrps_acs VALUES (null,\
 date("now","localtime"),time("now","localtime"),' + "%s" %BK + ',' + "%3d" %P1 + ',\
' + "%d" %P2 + ',' + "%3d" %TK + ',' + "%3d" %TR + ',' + "%2d" %TS + ',' + "%2d" %TV + ',\
' + "%.1f" % Tsa + ',' +"%.1f" % Ts1 + ',' +"%.1f" % Ts2 + ',' +"%.1f" %P + ',' + "%.1f" %W + ',\
' +"%.3f" %E + ',' +"%.3f" %TEg + ',' +"%.1f" %TEt + ',' + "%d" %Pt1 + ',' + "%d" %Pt2 + ')')

					connection.commit()
					print "DB='rotex' insert into Tabella 'tabrps_acs' OK"
					E = 0
					T = 0

		print "fine",s

if __name__ == "__main__":
	ser=serial.Serial(port='/dev/ttyS1',timeout=0.1)
	ricevi(ser).start()
	while Go:
		send=raw_input()
		print "invio:",send,ser.write(send)
		ser.write(send)
		if not send:
			Go=0 
	time.sleep(1)
	ser.close()
